     SUBROUTINE PREQ(NOBS)
        Use Blockc
        Use Block_obs
        Implicit Real (KIND=8) (A-G,O-Z)
        Implicit Integer (H-N)
        COMPLEX (KIND =8) :: Znorm
        COMPLEX (KIND=8), Dimension(:,:,:), Allocatable :: Collect2
        REAL( kind=8) :: collect4
        Character(16) :: filek,filek1, filek2
        INTEGER :: NOBS
        real(kind=8) :: momx, momy
        Interface
            Subroutine Fourier_Trans(gr,filek)
                Complex (Kind=8), dimension(:,:,:) :: gr
                Character (16) :: filek
            end Subroutine Fourier_Trans
            Subroutine orderparameter(gr1, file)
                real(kind=8) :: gr1
                Character (16) :: file
            end subroutine orderparameter
            Subroutine structurefactor(gr,filek,mom_x,mom_y,no1,no2)
                Complex (Kind=8), dimension(:,:,:) :: gr
                Character (16) :: filek
                real(kind=8) :: mom_x,mom_y
                integer :: no1, no2
            end subroutine structurefactor
            Subroutine realspace(gr,filek)
                Complex (Kind=8), dimension(:,:,:) :: gr
                Character (16) :: filek
            end subroutine realspace
        end Interface
!#define DEC
        INCLUDE 'mpif.h'
        INTEGER STATUS(MPI_STATUS_SIZE)
        CALL MPI_COMM_SIZE(MPI_COMM_WORLD,ISIZE,IERR)
        CALL MPI_COMM_RANK(MPI_COMM_WORLD,IRANK,IERR)
        ZNORM = CMPLX(1.D0,0.D0)/ DCMPLX( DBLE(NOBS), 0.D0 )
        spin = ZNORM * spin
        density = density / DBLE(NOBS)
        ferromagnetism = ferromagnetism / DBLE(NOBS)
        phasetot = phasetot/dble(Ncount)

        M2 = M2 / DBLE(NOBS)
        M2_deltaq = M2_deltaq / DBLE(NOBS)
        !M4 = M4 / DBLE(NOBS)
        !M4_yyk = M4_yyk / DBLE(NOBS)
        Gf_uu = Gf_uu / DBLE(NOBS)
        Gf_ud = Gf_ud / DBLE(NOBS)
        Gf = Gf / DBLE(NOBS)
        correlation_ratio = correlation_ratio / DBLE(NOBS)
        !Gf_du = Gf_du / DBLE(NOBS)
        !Gf_dd = Gf_dd / DBLE(NOBS)
        !Gk11_dk = Gk11_dk / DBLE(NOBS)
        !Gk12_dk = Gk12_dk / DBLE(NOBS)
        !Gk21_dk = Gk21_dk / DBLE(NOBS)
        !Gk22_dk = Gk22_dk / DBLE(NOBS)

        Allocate(Collect2(LQ,norb1,norb1))
        N = LQ*norb1*norb1 !
        Collect2 = CMPLX(0.D0,0.D0)
        CALL MPI_REDUCE(spin,Collect2,N,MPI_COMPLEX16,MPI_SUM,&
            & 0,MPI_COMM_WORLD,IERR)
        spin = Collect2/CMPLX(DBLE(ISIZE),0.D0)
        N=1
        Collect3 = 0.d0
        CALL MPI_REDUCE(phasetot,Collect3,N,MPI_REAL8,MPI_SUM,&
            & 0,MPI_COMM_WORLD,IERR)
        phasetot = Collect3/CMPLX(DBLE(ISIZE),0.D0) 
        collect4 = 0.0d0
        CALL MPI_REDUCE(density, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        density = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(ferromagnetism, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        ferromagnetism = collect4/CMPLX(DBLE(ISIZE),0.D0)

        collect4 = 0.0d0
        CALL MPI_REDUCE(M2, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        M2 = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(M4, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        M4 = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(M4_yyk, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        M4_yyk = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gf_uu, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gf_uu = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gf_ud, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gf_ud = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gf_du, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gf_du = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gf_dd, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gf_dd = collect4/CMPLX(DBLE(ISIZE),0.D0)

        collect4 = 0.0d0
        CALL MPI_REDUCE(Gk11_dk, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gk11_dk = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gk12_dk, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gk12_dk = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gk21_dk, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gk21_dk = collect4/CMPLX(DBLE(ISIZE),0.D0)
        collect4 = 0.0d0
        CALL MPI_REDUCE(Gk22_dk, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gk22_dk = collect4/CMPLX(DBLE(ISIZE),0.D0)

        collect4 = 0.0d0
        CALL MPI_REDUCE(M2_deltaq, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        M2_deltaq = collect4/CMPLX(DBLE(ISIZE),0.D0)

        CALL MPI_REDUCE(correlation_ratio, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        correlation_ratio = collect4/CMPLX(DBLE(ISIZE),0.D0)

        CALL MPI_REDUCE(Gf, Collect4, 1, MPI_REAL8, MPI_SUM, &
            &   0, MPI_COMM_WORLD, IERR)
        Gf = collect4/CMPLX(DBLE(ISIZE),0.D0)
     
        IF (IRANK.EQ.0) THEN    

            filek = "density"
            Call orderparameter(density, filek )
            filek = "ferromagnetism"
            Call orderparameter(ferromagnetism, filek )
            filek = "phasetot"
            call orderparameter(phasetot,filek)
            ! filek = "FMzz"
            ! momx = 0.d0
            ! momy = 0.d0
            ! call structurefactor(spin,filek,momx,momy,1,1)
            ! filek = "FMzz_deltaq"
            ! momx = 1.0d0/dble(NLx)
            ! momy = 1.0d0/dble(NLy)
            ! call structurefactor(spin,filek,momx,momy,1,1)

            filek = "M2"
            call orderparameter(M2, filek)
            filek = "M2_deltaq"
            call orderparameter(M2_deltaq, filek)
            ! filek = "M4"
            ! call orderparameter(M4, filek)
            ! filek = "M4_yyk"
            ! call orderparameter(M4_yyk, filek)
            filek = "Gf_uu"
            call orderparameter(Gf_uu, filek)
            filek = "Gf_ud"
            call orderparameter(Gf_ud, filek)
            filek = "Gf"
            call orderparameter(Gf, filek)
            filek = "correlation_ratio"
            call orderparameter(correlation_ratio, filek)
            !filek = "Gf_du"
            !call orderparameter(Gf_du, filek)
            !filek = "Gf_dd"
            !call orderparameter(Gf_dd, filek)
            
            !filek = "Gk11_dk"
            !call orderparameter(Gk11_dk, filek)
            !filek = "Gk12_dk"
            !call orderparameter(Gk12_dk, filek)
            !filek = "Gk21_dk"
            !call orderparameter(Gk21_dk, filek)
            !filek = "Gk22_dk"
            !call orderparameter(Gk22_dk, filek)

            
        ENDIF
    END SUBROUTINE PREQ
    
    Subroutine Fourier_Trans(gr,filek)
        Use Blockc
        Use Block_obs
        Implicit Real (KIND=8) (A-G,O-Z)
        Implicit Integer (H-N)
        Complex (Kind=8), dimension(:) :: gr
        Integer :: lp
        Character (16) :: filek
        Real (Kind=8) :: xk_p(2), aimj_p(2)
        Complex (Kind=8), allocatable , dimension(:) :: gk
        allocate (gk(LQ))
        gk = cmplx(0.d0,0.d0)
        do imj = 1,LQ
            lx = list(imj,1)
            ly = list(imj,2)
            aimj_p(1) = dble(lx)* a1_p(1) + dble(ly)* a2_p(1)
            aimj_p(2) = dble(lx)* a1_p(2) + dble(ly)* a2_p(2)
            do nk = 1,LQ
                kx = list(nk,1)
                ky = list(nk,2)
                xk_p(1) = dble(kx - 1) * b1_p(1)/dble(NLX) + dble(ky - 1) * b2_p(1)/dble(NLX)
                xk_p(2) = dble(kx - 1) * b1_p(2)/dble(NLX) + dble(ky - 1) * b2_p(2)/dble(NLY)
                gk(nk) = gk(nk) + &
                    & exp( cmplx( 0.d0, xk_p(1)*aimj_p(1) + xk_p(2)*aimj_p(2) ) ) * gr(imj)                
            enddo
        enddo
        gk = gk/cmplx(LQ,0.d0)
        OPEN (UNIT=20,FILE=filek,STATUS='UNKNOWN', action="write", position="append")
        do nk = 1,LQ
            kx = list(nk,1)
            ky = list(nk,2)
            !  write(20,*)  kx,ky
            xk_p(1) = dble(kx - 1) * b1_p(1)/dble(NLX) + dble(ky - 1) * b2_p(1)/dble(NLY)
            xk_p(2) = dble(kx - 1) * b1_p(2)/dble(NLX) + dble(ky - 1) * b2_p(2)/dble(NLY)
!! to convert the FFA convention to correct convention
            write(20,*) xk_p(1), xk_p(2)
            write(20,*) gk(nk)
        enddo
        close(20)
        deallocate (gk)
    end Subroutine Fourier_Trans
    
    Subroutine orderparameter(gr1, file)
        Use Blockc
        Use Block_obs
        real(kind=8) :: gr1
        Character (16) :: file
        OPEN (UNIT=20,FILE=file,STATUS='UNKNOWN', action="write", position="append")
        write(20,*) gr1      
        close(20)
    end Subroutine orderparameter
    
    Subroutine structurefactor(gr,filek,mom_x,mom_y,no1,no2)
         Use Blockc
         Use Block_obs
         Implicit Real (KIND=8) (A-G,O-Z)
         Implicit Integer (H-N)
         Complex (Kind=8), dimension(:,:,:) :: gr
         Integer :: lp
         Character (16) :: filek
         Real (Kind=8) :: mom_x,mom_y,xk_p(2), aimj_p(2)
         gk = cmplx(0.d0,0.d0)
         xk_p(1) = mom_x * b1_p(1) + mom_y * b2_p(1)
         xk_p(2) = mom_x * b1_p(2) + mom_y * b2_p(2)
         do imj = 1,LQ
             lx = list(imj,1)
             ly = list(imj,2)
            aimj_p(1) = dble(lx)* a1_p(1) + dble(ly)* a2_p(1)
            aimj_p(2) = dble(lx)* a1_p(2) + dble(ly)* a2_p(2)
            gk = gk + exp( cmplx( 0.d0, xk_p(1)*aimj_p(1)+xk_p(2)*aimj_p(2) ) ) * gr(imj,no1,no2)
         enddo
         gk = gk/cmplx(LQ,0.d0)
         OPEN (UNIT=20,FILE=filek,STATUS='UNKNOWN', action="write", position="append")
         write(20,*) real(gk)
         close(20)
    end subroutine structurefactor
    
    
        Subroutine realspace(gr,filek)
         Use Blockc
         Use Block_obs
         Implicit Real (KIND=8) (A-G,O-Z)
         Implicit Integer (H-N)
         Complex (Kind=8), dimension(:,:,:) :: gr
         Character (16) :: filek
    
         OPEN (UNIT=20,FILE=filek,STATUS='UNKNOWN', action="write", position="append")
         do imj = 1,LQ
             lx = list(imj,1)
             ly = list(imj,2)
             write(20,*) lx, ly
             do no1 = 1,norb
                 do no2 = 1, norb
                     write(20,*) gr(imj,no1,no2)
                 enddo
             enddo
         enddo
         close(20)
    end subroutine realspace